#include"FileSelector.h"


static gboolean delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data) 
{ 
	gtk_widget_hide(gtk_widget_get_toplevel(widget));
  return TRUE;
}


static void cancel_event(GtkButton *button, gpointer user_data)
{
	gtk_widget_hide(gtk_widget_get_toplevel(GTK_WIDGET(button)));

}

void FileSelector::create_it() {
	GtkWidget *OpenOkButton;
	GtkWidget *LoadCancelButton;

	widget = gtk_file_selection_new (title);
	//gtk_container_border_width (GTK_CONTAINER (OpenFileSel), 10);
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
						GTK_SIGNAL_FUNC (delete_event),
						NULL);

	OpenOkButton = GTK_FILE_SELECTION (widget)->ok_button;
	gtk_widget_show (OpenOkButton);
	GTK_WIDGET_SET_FLAGS (OpenOkButton, GTK_CAN_DEFAULT);
	if(func)
		gtk_signal_connect (GTK_OBJECT (OpenOkButton), "clicked", func, data);

	LoadCancelButton = GTK_FILE_SELECTION (widget)->cancel_button;
	gtk_widget_show (LoadCancelButton);
	GTK_WIDGET_SET_FLAGS (LoadCancelButton, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (LoadCancelButton), "clicked",
						GTK_SIGNAL_FUNC (cancel_event),
						NULL);
}

char *FileSelector::get_filename() {
	return  gtk_file_selection_get_filename(GTK_FILE_SELECTION(widget));
}


FileSelector::FileSelector(char *name="File Selecton") :widget(0),title(name),func((GtkSignalFunc)0),data(0) {
}

void FileSelector::signal_connect(GtkSignalFunc func,void *data=0) {
	this->func = func;
	this->data = data;
	if(widget)
		gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(widget)->ok_button), "clicked", func, data);
}

void FileSelector::raise() {
	if(!widget)
		create_it();
	gtk_widget_show(widget);
	gdk_window_raise(widget->window);
}

void FileSelector::hide() {
	gtk_widget_hide(widget);
}

